<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 26/11/13
 * Time: 09:59
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Facade;

use Folha\Logic\Cadastros;

class WizardEstrutura {

    const WND_ESTRUTURA     = 'gpe_wnd_estrutura_wzd';
    const WND_ENDERECO      = 'gpe_wnd_enderecoparc_wzd';
    const WND_COMUNICACAO   = 'gpe_wnd_comunicaparc_wzd';
    const WND_PARAMETROS    = 'gpe_tab_parametros_wzd';
    const WND_CONTCORRPARC  = 'gpe_contcorrparc_wzd';
    /**
     * Metodo 1003168 no metadados
     */
    public static function finalizaCadastro()
    {
        //tk_set_context_vars('NRPARAMFERIASM', 'gpe_tab_parametros_wzd', tk_get_field_value('NRPARAMFERIASM'));
       // tk_set_context_vars('NRPARAMFOLHAM', 'gpe_tab_parametros_wzd', tk_get_field_value('NRPARAMFOLHAM'));

        $nrparamferiasm = tk_get_context_vars('NRPARAMFERIASM', self::WND_PARAMETROS);
        $nrparamfolham  = tk_get_context_vars('NRPARAMFOLHAM', self::WND_PARAMETROS);

        $nrorg            = \Geral\Util\Ambiente::getNrorgTrabalho();
        $dtmescompetencia = \Geral\Util\Ambiente::getDtmescompetencia();
        //$dtmescompetencia = \HCM\Util\DateUtil::getDataDeString($dtmescompetencia);



        self::cadastraEstrutura($nrorg, $dtmescompetencia, $nrparamferiasm, $nrparamfolham);
    }

    private static function cadastraEstrutura($nrorg, $dtmescompetencia, $nrparamferiasm = null, $nrparamfolham = null)
    {   
        list($nmestrutura, $nmfantasia, $nmrazsocestrut, $dtinivigencia, $nrcalendario, $nrtipoestrutura, $cdcnpjestrut, $idtipoempr,
            $dtbasesindical, $cdsindical, $idparticipat, $idoptsimples, $cdnatujuri, $cdfpas, $cdcnae
            ) = self::getEstrutura();

        $cdtipoinscricao = ($cdcnpjestrut) ? 'CNPJ' : 'LIVRE';

        list($dsreferenciaende, $dscompleendereco, $nrcependereco, $nrimovelendereco, $dsendereco, $nmbairroendereco,
            $cdlogradouro, $cdmunicipio, $sgestado, $cdpais) = self::getEndereco();
            
        list($cdcomunicaparc, $cdprefixcomuparc, $cdformacomu) = self::getComunicacao();

        list($cdreducont, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr) = self::getContcorrparc();

        Cadastros::estruturaCompleta(
            $nrorg, $nrtipoestrutura, $dtinivigencia, $dtmescompetencia, $cdsindical, $dtbasesindical, $cdnatujuri,
            $nmrazsocestrut, $nmestrutura, $nmfantasia, $cdcnpjestrut, $idtipoempr, $idoptsimples, $idparticipat, $nrcalendario,
            $cdcnae, $cdfpas, $cdtipoinscricao, $cdcnpjestrut, $cdpais, $sgestado, $cdmunicipio, $cdlogradouro,
            $nmbairroendereco, 'PRINCIPAL', $nrcependereco, $dscompleendereco, $nrimovelendereco, $dsendereco,
            $dsreferenciaende, $cdformacomu, $cdprefixcomuparc,$cdcomunicaparc, $nrparamferiasm,
            $nrparamfolham, $cdreducont, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr
        );

        $msg = 'Cadastro realizado com sucesso!';
        tk_message($msg, 'sucess', 5000, true);

        tk_close_wizard('gpe_estrutura_wzd');

    }

    public static function getEstrutura()
    {
        $nmestrutura      = tk_get_context_vars('NMFANTASIA', self::WND_ESTRUTURA);
        $nmfantasia      = tk_get_context_vars('NMFANTASIA', self::WND_ESTRUTURA);
        $nmrazsocestrut  = tk_get_context_vars('NMRAZSOCESTRUT', self::WND_ESTRUTURA);
        if (!$nmrazsocestrut) {
            $nmrazsocestrut = $nmfantasia;
        }
        //$dtinivigencia   = tk_get_context_vars('DTINIVIGENCIA', self::WND_ESTRUTURA);
        if (tk_get_context_vars('DTINIVIGENCIA', self::WND_ESTRUTURA)) {
            $dtinivigencia = \HCM\Util\DateUtil::getDataDeString(tk_get_context_vars('DTINIVIGENCIA', self::WND_ESTRUTURA), "d/m/Y");
        }
        if (tk_get_context_vars('DTBASESINDICAL', self::WND_ESTRUTURA)) {
            $dtbasesindical = \HCM\Util\DateUtil::getDataDeString(tk_get_context_vars('DTBASESINDICAL', self::WND_ESTRUTURA), "d/m/Y");
        }
        $nrcalendario    = tk_get_context_vars('NRCALENDARIO', self::WND_ESTRUTURA);
        $nrtipoestrutura = tk_get_context_vars('NRTIPOESTRUTURA', self::WND_ESTRUTURA);
        $cdcnpjestrut    = tk_get_context_vars('CDCNPJESTRUT', self::WND_ESTRUTURA);
        $idtipoempr      = tk_get_context_vars('IDTIPOEMPR', self::WND_ESTRUTURA);
        $cdsindical      = tk_get_context_vars('CDSINDICAL', self::WND_ESTRUTURA);
        $idparticipat    = tk_get_context_vars('IDPARTICIPAT', self::WND_ESTRUTURA);
        $idoptsimples    = tk_get_context_vars('IDOPTSIMPLES', self::WND_ESTRUTURA);
        $cdnatujuri      = tk_get_context_vars('CDNATUJURI', self::WND_ESTRUTURA);
        $cdfpas          = tk_get_context_vars('CDFPAS', self::WND_ESTRUTURA);
        $cdcnae          = tk_get_context_vars('CDCNAE', self::WND_ESTRUTURA);
        return array(
            $nmestrutura, $nmfantasia, $nmrazsocestrut, $dtinivigencia, $nrcalendario, $nrtipoestrutura, $cdcnpjestrut, $idtipoempr,
            $dtbasesindical, $cdsindical, $idparticipat, $idoptsimples, $cdnatujuri, $cdfpas, $cdcnae
        );
    }

    public static function getEndereco()
    {
        $dsreferenciaende = tk_get_context_vars('DSREFERENCIAENDE', self::WND_ENDERECO);
        $dscompleendereco = tk_get_context_vars('DSCOMPLEENDERECO', self::WND_ENDERECO);
        $nrcependereco    = tk_get_context_vars('NRCEPENDERECO', self::WND_ENDERECO);
        $nrimovelendereco = tk_get_context_vars('NRIMOVELENDERECO', self::WND_ENDERECO);
        $dsendereco       = tk_get_context_vars('DSENDERECO', self::WND_ENDERECO);
        $nmbairroendereco = tk_get_context_vars('NMBAIRROENDERECO', self::WND_ENDERECO);
        $cdlogradouro     = tk_get_context_vars('CDLOGRADOURO', self::WND_ENDERECO);
        $cdmunicipio      = tk_get_context_vars('CDMUNICIPIO', self::WND_ENDERECO);
        $sgestado         = tk_get_context_vars('SGESTADO', self::WND_ENDERECO);
        $cdpais           = tk_get_context_vars('CDPAIS', self::WND_ENDERECO);
        return array(
            $dsreferenciaende, $dscompleendereco, $nrcependereco, $nrimovelendereco, $dsendereco, $nmbairroendereco,
            $cdlogradouro, $cdmunicipio, $sgestado, $cdpais
        );
    }

    public static function getComunicacao()
    {
        $cdcomunicaparc   = tk_get_context_vars('CDCOMUNICAPARC', self::WND_COMUNICACAO);
        if(tk_get_context_vars('CDPREFIXCOMUPARC', self::WND_COMUNICACAO)){
            $cdprefixcomuparc = tk_get_context_vars('CDPREFIXCOMUPARC', self::WND_COMUNICACAO);
        }else {
            $cdprefixcomuparc = '';
        }
        $cdformacomu = tk_get_context_vars('CDFORMACOMU', self::WND_COMUNICACAO);
        return array($cdcomunicaparc, $cdprefixcomuparc, $cdformacomu);
    }

    public static function getContcorrparc()
    {
        $cdreducont   = tk_get_context_vars('CDREDUCONT', self::WND_CONTCORRPARC);;
        $cdbanco      = tk_get_context_vars('CDBANCO', self::WND_CONTCORRPARC);
        $cdagencia    = tk_get_context_vars('CDAGENCIA', self::WND_CONTCORRPARC);
        $cdcontcorr   = tk_get_context_vars('CDCONTCORR', self::WND_CONTCORRPARC);
        $nrtpcontcorr = tk_get_context_vars('NRTPCONTCORR', self::WND_CONTCORRPARC);

        return array($cdreducont, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr);
    }
    




    public static function duvidaAoProseguir()
    {
        $msg = 'Você pode voltar os passos, conferir os parâmetros informados, depois gravar a estrutura.';
        tk_message($msg, 'info', 2500);
    }

}