/* Tabela PRODINTDOS: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela PRODINTDOS */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Item do PRODINTDOS, utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_EST_PRODINTDOS
AFTER DELETE OR INSERT OR UPDATE
ON PRODINTDOS FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN

      IF :OLD.IDPRODINTDOS IS NOT NULL THEN
         V_DESC := V_DESC || 'TpProd=' || :OLD.IDPRODINTDOS;
      END IF;

      IF :OLD.CDPRODINTDOS IS NOT NULL THEN
         V_DESC := V_DESC || ' ProdExt=' || :OLD.CDPRODINTDOS;
      END IF;

      IF :OLD.VRFATORCODOS IS NOT NULL THEN
         V_DESC := V_DESC || ' FatorConv=' || :OLD.VRFATORCODOS;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDPRODUTO || :OLD.CDPRODINTDOS;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.IDPRODINTDOS,'!')  <> NVL(:NEW.IDPRODINTDOS,'!')) OR
            (NVL(:OLD.CDPRODINTDOS,'!')  <> NVL(:NEW.CDPRODINTDOS,'!')) OR
            (NVL(:OLD.VRFATORCODOS,1)  <> NVL(:NEW.VRFATORCODOS,1)) THEN

            IF NVL(:NEW.IDPRODINTDOS,'!') <> NVL(:OLD.IDPRODINTDOS,'!') THEN
               V_DESC := V_DESC || 'TpProd=' || :NEW.IDPRODINTDOS;
            END IF;

            IF NVL(:NEW.CDPRODINTDOS,'!') <> NVL(:OLD.CDPRODINTDOS,'!') THEN
               V_DESC := V_DESC || ' ProdExt=' || :NEW.CDPRODINTDOS;
            END IF;

            IF NVL(:NEW.VRFATORCODOS,1) <> NVL(:OLD.VRFATORCODOS,1) THEN
               V_DESC := V_DESC || ' FatorConv=' || :NEW.VRFATORCODOS;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDPRODUTO || :OLD.CDPRODINTDOS;
         END IF;
      ELSE
         IF :NEW.IDPRODINTDOS IS NOT NULL THEN
            V_DESC := V_DESC || 'TpProd=' || :NEW.IDPRODINTDOS;
         END IF;

         IF :NEW.CDPRODINTDOS IS NOT NULL THEN
            V_DESC := V_DESC || ' ProdExt=' || :NEW.CDPRODINTDOS;
         END IF;

         IF :NEW.VRFATORCODOS IS NOT NULL THEN
            V_DESC := V_DESC || ' FatorConv=' || :NEW.VRFATORCODOS;
         END IF;
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDPRODUTO || :NEW.CDPRODINTDOS;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('PRODINTDOS',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_EST_PRODINTDOS','4.09.060'); END;
/
