/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FAMSALDOFILI                                             */
/* Tabela : FAMSALDOFILI                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 23/08/2006 - Wanderson Aloisio                                             */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FAMSALDOFILI'  and
            type = 'TR' and
            u.uid = o.uid and
            u.name = USER)
   DROP TRIGGER DTULTATU_FAMSALDOFILI
GO

CREATE TRIGGER DTULTATU_FAMSALDOFILI
ON FAMSALDOFILI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FAMSALDOFILI', CDFILIAL, 'CDFILIAL='+CDFILIAL+';CDFAMILISALD='+CDFAMILISALD+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FAMSALDOFILI
      SET DTULTATUFASF = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(FAMSALDOFILI.NRORDAPRSALD   ,0) = ISNULL(INSERTED.NRORDAPRSALD   ,0)) AND
            (ISNULL(FAMSALDOFILI.IDSALDNEGFAM   ,0) = ISNULL(INSERTED.IDSALDNEGFAM   ,0)) AND
            (ISNULL(FAMSALDOFILI.VRCONSDIAFAM   ,0) = ISNULL(INSERTED.VRCONSDIAFAM   ,0)) AND
		(ISNULL(FAMSALDOFILI.IDPERMCARGACRED,0) = ISNULL(INSERTED.IDPERMCARGACRED,0));
   END;
END;
GO

UPDATE FAMSALDOFILI SET DTULTATUFASF = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUFASF IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUFASF' and
            type = 'D')
   ALTER TABLE FAMSALDOFILI DROP CONSTRAINT DEFAULT_DTULTATUFASF
GO

ALTER TABLE FAMSALDOFILI ADD CONSTRAINT DEFAULT_DTULTATUFASF
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUFASF
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_FAMSALDOFILI','4.11.194';
GO

