/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8340_SUPVIE_FORN_REG.SQL                                             */
/*                                                                            */
/* Descrio:                                                                 */
/* Retorna os Fornecedores e as Regies que ele atende.                       */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 28/06/2000 - Alexis Tolentino                                              */
/*                                                                            */
/******************************************************************************/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE 
           O.NAME = 'FORN_REG' AND 
	   TYPE = 'V' 		  AND
	   U.UID = O.UID          AND 
	   U.NAME = USER)

   DROP VIEW FORN_REG
GO

CREATE VIEW FORN_REG AS
SELECT
     FORREG.CDFORNECED,
     FORREG.IDTPIJURFORN,
     FORREG.NRINSJURFORN,
     FORREG.NMRAZSOCFORN,
     FORREG.NMFANTFORN,
     FORREG.IDTPDESCFORN,
     FORREG.VRPEDESCFORN,
     FORREG.IDTPFRETFORN,
     FORREG.CDQUALIF,
     FORREG.IDFORNAUTO,
     FORREG.DTVALQUALIF,
     FORREG.CDREGIAO,
     FORREG.NMREGIAO
   FROM (SELECT
           FORNECEDOR.CDFORNECED,
           FORNECEDOR.IDTPIJURFORN,
           FORNECEDOR.NRINSJURFORN,
           FORNECEDOR.NMRAZSOCFORN,
           FORNECEDOR.NMFANTFORN,
           FORNECEDOR.IDTPDESCFORN,
           FORNECEDOR.VRPEDESCFORN,
           FORNECEDOR.IDTPFRETFORN, 
           FORNECEDOR.CDQUALIF,
           FORNECEDOR.IDFORNAUTO,
           FORNECEDOR.DTVALQUALIF,
           REGIAO.CDREGIAO,
           REGIAO.NMREGIAO
         FROM
           FORNECEDOR, REGIAO
         WHERE
           FORNECEDOR.IDSITUCADA = 'A') FORREG LEFT JOIN REFOREG
      ON (REFOREG.CDFORNECED = FORREG.CDFORNECED AND
          REFOREG.CDREGIAO   = FORREG.CDREGIAO )
   
WHERE
   (REFOREG.CDFORNECED IS NULL)  AND
   (REFOREG.CDREGIAO IS NULL) 
GO